package mods.immibis.redlogic;

public interface IRedstoneUpdatableTile {
	/**
	 * Called when a wire pointing at this block updates, even if it wouldn't cause a block update or provide power to vanilla things (e.g. if it's insulated).
	 * Note that if the wire is providing normal power anyway, it will not call this.
	 * Currently used for: insulated wire input to gates (the wire connects to the gate because the gate returns true from
	 * canProvidePower)
	 */
	public void onRedstoneInputChanged();
}
