package mods.immibis.redlogic.wires;

import mods.immibis.redlogic.IBundledEmittingTile;
import mods.immibis.redlogic.IBundledUpdatableTile;
import mods.immibis.redlogic.Utils;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.world.World;

public class InsulatedRedAlloyTile extends RedAlloyTile implements IBundledUpdatableTile {
	@Override
	protected boolean canConnectToWire(WireTile wire) {
		if(wire.getType() == EnumWireType.RED_ALLOY || wire instanceof BundledTile)
			return true;
		return wire.getType() == getType();
	}
	
	@Override
	public boolean canProvideWeakPowerInDirection(int dir) {
		//return connectsInDirection(dir) && super.canProvideWeakPowerInDirection(dir);
		return false;
	}
	
	@Override
	public boolean canProvideStrongPowerInDirection(int dir) {
		return false;
	}
	
	@Override
	protected int getInputPowerStrength(World worldObj, int x, int y, int z, int dir, int side, boolean countWires) {
		int rv = Utils.getPowerStrength(worldObj, x, y, z, dir, side, countWires);
		
		if(rv > 0) return rv; // no block emits bundled and normal power from the same side
		
		TileEntity te = worldObj.getBlockTileEntity(x, y, z);
		if(te instanceof IBundledEmittingTile) {
			int colour = getType().ordinal() - EnumWireType.INSULATED_0.ordinal();
			int bcStrength = ((IBundledEmittingTile)te).getBundledCableStrength()[colour] & 0xFF;
			rv = Math.max(rv, bcStrength);
		}
		
		return rv;
	}

	@Override
	public void onBundledInputChanged() {
		updateSignal(null);
	}
}
